from pygments.style import Style
from pygments.token import Token
from pygments.formatters import HtmlFormatter

class NewStyle(Style):
    default_style = ""

    night_blue =  "#204A87"
    purple = "#68175A"
    silver = "#7A5505"
    dark_red = "#880000"
    grey = "#586178"

    styles = {
        Token.Whitespace: "",
        Token.Text: "",
        Token.Keyword: "bold",
        Token.Comment: grey,
        Token.String: silver,
        Token.String.Escape: dark_red,
        Token.String.Symbol: "noinherit",
        Token.Pitch: "", #"#911520",
        Token.Number: silver, # includes durations
        # A bare 11 is not distinguishable from a number, so we highlight
        # the same.
        Token.ChordModifier: silver,
        Token.Name.Lvalue: "", #night_blue,
        Token.Name.BackslashReference: night_blue,
        Token.Name.Builtin.MusicCommand: night_blue,
        Token.Name.Builtin.PaperVariable: purple,
        Token.Name.Builtin.HeaderVariable: purple,
        Token.Name.Builtin.MusicFunction: night_blue,
        Token.Name.Builtin.Clef: "",
        Token.Name.Builtin.Scale: night_blue,
        Token.Name.Builtin.RepeatType: night_blue,
        Token.Name.Builtin.Dynamic: purple,
        Token.Name.Builtin.Articulation: purple,
        Token.Name.Builtin.SchemeFunction: silver,
        Token.Name.Builtin.SchemeBuiltin: "bold",
        Token.Name.Builtin.MarkupCommand: purple,
        Token.Name.Builtin.Context: purple,
        Token.Name.Builtin.ContextProperty: purple,
        Token.Name.Builtin.Grob: dark_red,
        Token.Name.Builtin.GrobProperty: dark_red,
        Token.Name.Builtin.Translator: purple,
    }

with open("lilypond-highlighting.css", "w") as file:
    file.write(HtmlFormatter(style=NewStyle).get_style_defs(".highlight"))
